Index: sasmodels/models/bcc.py
===================================================================
--- sasmodels/models/bcc.py	(revision 3c56da87f0995bdde77f4183b68e77b81584dde0)
+++ sasmodels/models/bcc.py	(revision 485aee225e23a0dad14b9acfc70c0c7072e650b9)
@@ -113,19 +113,18 @@
     assumed to be isotropic and characterized by a Gaussian distribution.
     """
-category="shape:paracrystal"
+category = "shape:paracrystal"
 
-parameters = [
-#   [ "name", "units", default, [lower, upper], "type","description" ],
-    [ "dnn", "Ang", 220, [-inf,inf],"","Nearest neighbour distance"],
-    [ "d_factor", "", 0.06,[-inf,inf],"","Paracrystal distortion factor" ],
-    [ "radius", "Ang",  40, [0, inf], "volume","Particle radius" ],
-    [ "sld", "1e-6/Ang^2", 4, [-inf,inf], "", "Particle scattering length density" ],
-    [ "solvent_sld", "1e-6/Ang^2", 1, [-inf,inf], "", "Solvent scattering length density" ],
-    [ "theta", "degrees", 60, [-inf, inf], "orientation","In plane angle" ],
-    [ "phi", "degrees", 60, [-inf, inf], "orientation","Out of plane angle" ],
-    [ "psi", "degrees", 60, [-inf,inf], "orientation","Out of plane angle"]
-    ]
+#             ["name", "units", default, [lower, upper], "type","description" ],
+parameters = [["dnn", "Ang", 220, [-inf, inf], "", "Nearest neighbour distance"],
+              ["d_factor", "", 0.06, [-inf, inf], "", "Paracrystal distortion factor"],
+              ["radius", "Ang", 40, [0, inf], "volume", "Particle radius"],
+              ["sld", "1e-6/Ang^2", 4, [-inf, inf], "", "Particle scattering length density"],
+              ["solvent_sld", "1e-6/Ang^2", 1, [-inf, inf], "", "Solvent scattering length density"],
+              ["theta", "degrees", 60, [-inf, inf], "orientation", "In plane angle"],
+              ["phi", "degrees", 60, [-inf, inf], "orientation", "Out of plane angle"],
+              ["psi", "degrees", 60, [-inf, inf], "orientation", "Out of plane angle"]
+             ]
 
-source = [ "lib/J1.c", "lib/gauss150.c", "bcc.c" ]
+source = ["lib/J1.c", "lib/gauss150.c", "bcc.c"]
 
 # parameters for demo
@@ -143,5 +142,4 @@
 # For testing against the old sasview models, include the converted parameter
 # names and the target sasview model name.
-oldname='BCCrystalModel'
-oldpars=dict(sld='sldSph',
-             solvent_sld='sldSolv')
+oldname = 'BCCrystalModel'
+oldpars = dict(sld='sldSph', solvent_sld='sldSolv')
Index: sasmodels/models/broad_peak.py
===================================================================
--- sasmodels/models/broad_peak.py	(revision 3c56da87f0995bdde77f4183b68e77b81584dde0)
+++ sasmodels/models/broad_peak.py	(revision 485aee225e23a0dad14b9acfc70c0c7072e650b9)
@@ -60,44 +60,32 @@
       lorentz_exp = Lorentzian exponent
       background = Incoherent background"""
-category="shape-independent"
+category = "shape-independent"
 
-parameters = [
-#   [ "name", "units", default, [lower, upper], "type",
-#     "description" ],
-
-    [ "porod_scale", "", 1.0e-05, [-inf,inf], "",
-      "Power law scale factor" ],
-    [ "porod_exp", "", 3.0, [-inf,inf], "",
-      "Exponent of power law" ],
-    [ "lorentz_scale", "", 10.0, [-inf,inf], "",
-      "Scale factor for broad Lorentzian peak" ],
-    [ "lorentz_length", "Ang",  50.0, [-inf, inf], "",
-      "Lorentzian screening length" ],
-    [ "peak_pos", "1/Ang",  0.1, [-inf, inf], "",
-      "Peak postion in q" ],
-    [ "lorentz_exp", "",  2.0, [-inf, inf], "",
-      "exponent of Lorentz function" ],
-    ]
-
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [["porod_scale", "", 1.0e-05, [-inf, inf], "", "Power law scale factor"],
+              ["porod_exp", "", 3.0, [-inf, inf], "", "Exponent of power law"],
+              ["lorentz_scale", "", 10.0, [-inf, inf], "", "Scale factor for broad Lorentzian peak"],
+              ["lorentz_length", "Ang", 50.0, [-inf, inf], "", "Lorentzian screening length"],
+              ["peak_pos", "1/Ang", 0.1, [-inf, inf], "", "Peak postion in q"],
+              ["lorentz_exp", "", 2.0, [-inf, inf], "", "exponent of Lorentz function"],
+             ]
 
 def Iq(q, porod_scale, porod_exp, lorentz_scale, lorentz_length, peak_pos, lorentz_exp):
-    inten = (porod_scale/q**porod_exp + lorentz_scale
-        / (1.0 + (abs(q-peak_pos)*lorentz_length)**lorentz_exp))
+    inten = (porod_scale / q ** porod_exp + lorentz_scale
+             / (1.0 + (abs(q - peak_pos) * lorentz_length) ** lorentz_exp))
     return inten
 Iq.vectorized = True  # Iq accepts an array of Q values
 
 def Iqxy(qx, qy, *args):
-    return Iq(sqrt(qx**2 + qy**2), *args)
+    return Iq(sqrt(qx ** 2 + qy ** 2), *args)
 Iqxy.vectorized = True # Iqxy accepts an array of Qx, Qy values
 
 
-demo = dict(
-    scale=1, background=0,
-    porod_scale=1.0e-05, porod_exp=3,
-    lorentz_scale=10,lorentz_length=50, peak_pos=0.1, lorentz_exp=2,
-    )
+demo = dict(scale=1, background=0,
+            porod_scale=1.0e-05, porod_exp=3,
+            lorentz_scale=10, lorentz_length=50, peak_pos=0.1, lorentz_exp=2)
 
 oldname = "BroadPeakModel"
 oldpars = dict(porod_scale='scale_p', porod_exp='exponent_p',
-        lorentz_scale='scale_l', lorentz_length='length_l', peak_pos='q_peak',
-        lorentz_exp='exponent_l', scale=None)
+               lorentz_scale='scale_l', lorentz_length='length_l', peak_pos='q_peak',
+               lorentz_exp='exponent_l', scale=None)
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision a5d0d008778409dd90a86aa3db6037187ed3ff57)
+++ sasmodels/models/capped_cylinder.py	(revision 485aee225e23a0dad14b9acfc70c0c7072e650b9)
@@ -115,63 +115,53 @@
 title = "Right circular cylinder with spherical end caps and uniform SLD"
 description = """That is, a sphereocylinder
-	with end caps that have a radius larger than
-	that of the cylinder and the center of the
-	end cap radius lies within the cylinder.
-	Note: As the length of cylinder -->0,
-	it becomes a ConvexLens.
-	It must be that radius <(=) cap_radius.
-	[Parameters];
-	scale: volume fraction of spheres,
-	background:incoherent background,
-	radius: radius of the cylinder,
-	length: length of the cylinder,
-	cap_radius: radius of the semi-spherical cap,
-	sld: SLD of the capped cylinder,
-	solvent_sld: SLD of the solvent.
+    with end caps that have a radius larger than
+    that of the cylinder and the center of the
+    end cap radius lies within the cylinder.
+    Note: As the length of cylinder -->0,
+    it becomes a ConvexLens.
+    It must be that radius <(=) cap_radius.
+    [Parameters];
+    scale: volume fraction of spheres,
+    background:incoherent background,
+    radius: radius of the cylinder,
+    length: length of the cylinder,
+    cap_radius: radius of the semi-spherical cap,
+    sld: SLD of the capped cylinder,
+    solvent_sld: SLD of the solvent.
 """
 category = "shape:cylinder"
 
-parameters = [
-    #   [ "name", "units", default, [lower, upper], "type",
-    #     "description" ],
-    [ "sld", "1e-6/Ang^2", 4, [-inf,inf], "",
-      "Cylinder scattering length density" ],
-    [ "solvent_sld", "1e-6/Ang^2", 1, [-inf,inf], "",
-      "Solvent scattering length density" ],
-    [ "radius", "Ang",  20, [0, inf], "volume",
-      "Cylinder radius" ],
-    # TODO: use an expression for cap radius with fixed bounds.
-    # The current form requires cap radius R bigger than cylinder radius r.
-    # Could instead use R/r in [1,inf], r/R in [0,1], or the angle between
-    # cylinder and cap in [0,90].  The problem is similar for the barbell
-    # model.  Propose r/R in [0,1] in both cases, with the model specifying
-    # cylinder radius in the capped cylinder model and sphere radius in the
-    # barbell model.  This leads to the natural value of zero for no cap
-    # in the capped cylinder, and zero for no bar in the barbell model.  In
-    # both models, one would be a pill.
-    [ "cap_radius", "Ang", 20, [0, inf], "volume",
-      "Cap radius" ],
-    [ "length", "Ang",  400, [0, inf], "volume",
-      "Cylinder length" ],
-    [ "theta", "degrees", 60, [-inf, inf], "orientation",
-      "In plane angle" ],
-    [ "phi", "degrees", 60, [-inf, inf], "orientation",
-      "Out of plane angle" ],
-    ]
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [["sld", "1e-6/Ang^2", 4, [-inf, inf], "",
+               "Cylinder scattering length density"],
+              ["solvent_sld", "1e-6/Ang^2", 1, [-inf, inf], "",
+               "Solvent scattering length density"],
+              ["radius", "Ang", 20, [0, inf], "volume", "Cylinder radius"],
+              # TODO: use an expression for cap radius with fixed bounds.
+              # The current form requires cap radius R bigger than cylinder radius r.
+              # Could instead use R/r in [1,inf], r/R in [0,1], or the angle between
+              # cylinder and cap in [0,90].  The problem is similar for the barbell
+              # model.  Propose r/R in [0,1] in both cases, with the model specifying
+              # cylinder radius in the capped cylinder model and sphere radius in the
+              # barbell model.  This leads to the natural value of zero for no cap
+              # in the capped cylinder, and zero for no bar in the barbell model.  In
+              # both models, one would be a pill.
+              ["cap_radius", "Ang", 20, [0, inf], "volume", "Cap radius"],
+              ["length", "Ang", 400, [0, inf], "volume", "Cylinder length"],
+              ["theta", "degrees", 60, [-inf, inf], "orientation", "In plane angle"],
+              ["phi", "degrees", 60, [-inf, inf], "orientation", "Out of plane angle"],
+             ]
 
-source = [ "lib/J1.c", "lib/gauss76.c", "capped_cylinder.c" ]
+source = ["lib/J1.c", "lib/gauss76.c", "capped_cylinder.c"]
 
-
-demo = dict(
-    scale=1, background=0,
-    sld=6, solvent_sld=1,
-    radius=260, cap_radius=290, length=290,
-    theta=30, phi=15,
-    radius_pd=.2, radius_pd_n=1,
-    cap_radius_pd=.2, cap_radius_pd_n=1,
-    length_pd=.2, length_pd_n=10,
-    theta_pd=15, theta_pd_n=45,
-    phi_pd=15, phi_pd_n=1,
-    )
+demo = dict(scale=1, background=0,
+            sld=6, solvent_sld=1,
+            radius=260, cap_radius=290, length=290,
+            theta=30, phi=15,
+            radius_pd=.2, radius_pd_n=1,
+            cap_radius_pd=.2, cap_radius_pd_n=1,
+            length_pd=.2, length_pd_n=10,
+            theta_pd=15, theta_pd_n=45,
+            phi_pd=15, phi_pd_n=1)
 oldname = 'CappedCylinderModel'
 oldpars = dict(sld='sld_capcyl', solvent_sld='sld_solv',
Index: sasmodels/models/core_shell_cylinder.py
===================================================================
--- sasmodels/models/core_shell_cylinder.py	(revision a5d0d008778409dd90a86aa3db6037187ed3ff57)
+++ sasmodels/models/core_shell_cylinder.py	(revision 485aee225e23a0dad14b9acfc70c0c7072e650b9)
@@ -111,73 +111,69 @@
 P(q,alpha)= scale/Vs*f(q)^(2) + background,
       where: f(q)= 2(core_sld - solvant_sld)
-		* Vc*sin[qLcos(alpha/2)]
-		/[qLcos(alpha/2)]*J1(qRsin(alpha))
-		/[qRsin(alpha)]+2(shell_sld-solvent_sld)
-		*Vs*sin[q(L+T)cos(alpha/2)][[q(L+T)
-		*cos(alpha/2)]*J1(q(R+T)sin(alpha))
-		/q(R+T)sin(alpha)]
+        * Vc*sin[qLcos(alpha/2)]
+        /[qLcos(alpha/2)]*J1(qRsin(alpha))
+        /[qRsin(alpha)]+2(shell_sld-solvent_sld)
+        *Vs*sin[q(L+T)cos(alpha/2)][[q(L+T)
+        *cos(alpha/2)]*J1(q(R+T)sin(alpha))
+        /q(R+T)sin(alpha)]
 
-	alpha:is the angle between the axis of
-		the cylinder and the q-vector
-	Vs: the volume of the outer shell
-	Vc: the volume of the core
-	L: the length of the core
-    	shell_sld: the scattering length density of the shell
-	solvent_sld: the scattering length density of the solvent
-	background: the background
-	T: the thickness
-    	R+T: is the outer radius
- 	L+2T: The total length of the outershell
-	J1: the first order Bessel function
- 	theta: axis_theta of the cylinder
- 	phi: the axis_phi of the cylinder
+    alpha:is the angle between the axis of
+        the cylinder and the q-vector
+    Vs: the volume of the outer shell
+    Vc: the volume of the core
+    L: the length of the core
+        shell_sld: the scattering length density of the shell
+    solvent_sld: the scattering length density of the solvent
+    background: the background
+    T: the thickness
+        R+T: is the outer radius
+     L+2T: The total length of the outershell
+    J1: the first order Bessel function
+     theta: axis_theta of the cylinder
+     phi: the axis_phi of the cylinder
 """
 category = "shape:cylinder"
 
-parameters = [
-#   [ "name", "units", default, [lower, upper], "type",
-#     "description" ],
-    [ "core_sld", "1e-6/Ang^2", 4, [-inf,inf], "",
-      "Cylinder core scattering length density" ],
-    [ "shell_sld", "1e-6/Ang^2", 4, [-inf,inf], "",
-      "Cylinder shell scattering length density" ],
-    [ "solvent_sld", "1e-6/Ang^2", 1, [-inf,inf], "",
-      "Solvent scattering length density" ],
-    [ "radius", "Ang",  20, [0, inf], "volume",
-      "Cylinder core radius" ],
-    [ "thickness", "Ang",  20, [0, inf], "volume",
-      "Cylinder shell thickness" ],
-    [ "length", "Ang",  400, [0, inf], "volume",
-      "Cylinder length" ],
-    [ "theta", "degrees", 60, [-inf, inf], "orientation",
-      "In plane angle" ],
-    [ "phi", "degrees", 60, [-inf, inf], "orientation",
-      "Out of plane angle" ],
-    ]
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [["core_sld", "1e-6/Ang^2", 4, [-inf, inf], "",
+               "Cylinder core scattering length density"],
+              ["shell_sld", "1e-6/Ang^2", 4, [-inf, inf], "",
+               "Cylinder shell scattering length density"],
+              ["solvent_sld", "1e-6/Ang^2", 1, [-inf, inf], "",
+               "Solvent scattering length density"],
+              ["radius", "Ang", 20, [0, inf], "volume",
+               "Cylinder core radius"],
+              ["thickness", "Ang", 20, [0, inf], "volume",
+               "Cylinder shell thickness"],
+              ["length", "Ang", 400, [0, inf], "volume",
+               "Cylinder length"],
+              ["theta", "degrees", 60, [-inf, inf], "orientation",
+               "In plane angle"],
+              ["phi", "degrees", 60, [-inf, inf], "orientation",
+               "Out of plane angle"],
+             ]
 
-source = [ "lib/J1.c", "lib/gauss76.c", "core_shell_cylinder.c"]
+source = ["lib/J1.c", "lib/gauss76.c", "core_shell_cylinder.c"]
 
 def ER(radius, thickness, length):
     radius = radius + thickness
-    length = length + 2*thickness
-    ddd = 0.75*radius*(2*radius*length + (length+radius)*(length+pi*radius))
-    return 0.5 * (ddd)**(1./3.)
+    length = length + 2 * thickness
+    ddd = 0.75 * radius * (2 * radius * length + (length + radius) * (length + pi * radius))
+    return 0.5 * (ddd) ** (1. / 3.)
 
 def VR(radius, thickness, length):
-    whole = pi * (radius+thickness)**2 * (length+2*thickness)
-    core = pi * radius**2 * length
-    return whole, whole-core
+    whole = pi * (radius + thickness) ** 2 * (length + 2 * thickness)
+    core = pi * radius ** 2 * length
+    return whole, whole - core
 
-demo = dict(
-    scale=1, background=0,
-    core_sld=6, shell_sld=8, solvent_sld=1,
-    radius=45, thickness=25, length=340,
-    theta=30, phi=15,
-    radius_pd=.2, radius_pd_n=1,
-    length_pd=.2, length_pd_n=10,
-    thickness_pd=.2, thickness_pd_n=10,
-    theta_pd=15, theta_pd_n=45,
-    phi_pd=15, phi_pd_n=1,
-    )
+demo = dict(scale=1, background=0,
+            core_sld=6, shell_sld=8, solvent_sld=1,
+            radius=45, thickness=25, length=340,
+            theta=30, phi=15,
+            radius_pd=.2, radius_pd_n=1,
+            length_pd=.2, length_pd_n=10,
+            thickness_pd=.2, thickness_pd_n=10,
+            theta_pd=15, theta_pd_n=45,
+            phi_pd=15, phi_pd_n=1)
 oldname = 'CoreShellCylinderModel'
 oldpars = dict(theta='axis_theta', phi='axis_phi')