Index: src/sas/qtgui/GuiManager.py
===================================================================
--- src/sas/qtgui/GuiManager.py	(revision a8ec5b10d64178372c44951ceeddefc2d6c90504)
+++ src/sas/qtgui/GuiManager.py	(revision 0532d7c15f8e5962a80241e030a2c4d28323411d)
@@ -141,5 +141,5 @@
         #self.KIESSIGCalculator = DensityPanel(self)#KiessigPanel(self)
         self.KIESSIGCalculator = KiessigPanel(self)
-        self.SlitSizeCalculator = SlitSizeCalculator(self._parent, self, manager=self._data_manager)
+        self.SlitSizeCalculator = SlitSizeCalculator(self._parent)
     def statusBarSetup(self):
         """
Index: src/sas/qtgui/SlitSizeCalculator.py
===================================================================
--- src/sas/qtgui/SlitSizeCalculator.py	(revision 253e71709965f90b7bc2117d8f92970d57be3756)
+++ src/sas/qtgui/SlitSizeCalculator.py	(revision 0532d7c15f8e5962a80241e030a2c4d28323411d)
@@ -7,8 +7,8 @@
 from sas.sascalc.calculator.slit_length_calculator import SlitlengthCalculator
 
-import sys
+import os
 
 class SlitSizeCalculator(QtGui.QDialog, Ui_SlitSizeCalculator):
-    def __init__(self, parent=None, guimanager=None, manager=None):
+    def __init__(self, parent=None):
         super(SlitSizeCalculator, self).__init__()
         self.setupUi(self)
@@ -16,6 +16,4 @@
         self.setWindowTitle("Slit Size Calculator")
         self._parent = parent
-        self._guimanager = guimanager
-        self._manager = manager
 
         self.thickness = SlitlengthCalculator()
@@ -28,4 +26,5 @@
         # no reason to have this widget resizable
         self.setFixedSize(self.minimumSizeHint())
+
 
     def onHelp(self):
@@ -56,8 +55,7 @@
         data = loader.load(path_str)
 
-        self.deltaq_in.setText(path_str)
+        self.data_file.setText(os.path.basename(path_str))
         #We are loading data for one model only therefor index 0
-        self.complete_loading(data)
-        #Complete loading here
+        self.calculateSlitSize(data)
 
     def chooseFile(self):
@@ -69,5 +67,5 @@
         # But only with Qt built-in dialog (non-platform native)
         path = QtGui.QFileDialog.getOpenFileName(self, "Choose a file", "",
-                "SAS data 1D (*.txt *.TXT *.dat *.DAT)", None,
+                "SAXSess 1D data (*.txt *.TXT *.dat *.DAT)", None,
                 QtGui.QFileDialog.DontUseNativeDialog)
         if path is None:
@@ -85,5 +83,5 @@
         self.close()
 
-    def complete_loading(self, data=None):
+    def calculateSlitSize(self, data=None):
         """
             Complete the loading and compute the slit size
@@ -112,7 +110,7 @@
              raise RuntimeError, msg
 
-        print("Slit lenght", slit_length)
-        self.lengthscale_out.setText(str(slit_length))
+        slit_length_str = "{:.5f}".format(slit_length)
+        self.slit_length_out.setText(slit_length_str)
         #Display unit
-        self.lineEdit.setText("[UNKNOWN]")
+        self.unit_out.setText("[Unknown]")
 
Index: src/sas/qtgui/UI/SlitSizeCalculator.ui
===================================================================
--- src/sas/qtgui/UI/SlitSizeCalculator.ui	(revision 6b9d41d6f2d73268c04eb96280f4325c9dfbcf37)
+++ src/sas/qtgui/UI/SlitSizeCalculator.ui	(revision 0532d7c15f8e5962a80241e030a2c4d28323411d)
@@ -22,17 +22,4 @@
   </property>
   <layout class="QGridLayout" name="gridLayout_3">
-   <item row="2" column="0">
-    <spacer name="verticalSpacer_2">
-     <property name="orientation">
-      <enum>Qt::Vertical</enum>
-     </property>
-     <property name="sizeHint" stdset="0">
-      <size>
-       <width>20</width>
-       <height>40</height>
-      </size>
-     </property>
-    </spacer>
-   </item>
    <item row="0" column="0">
     <widget class="QGroupBox" name="groupBox">
@@ -51,8 +38,8 @@
         </item>
         <item>
-         <widget class="QLineEdit" name="deltaq_in">
+         <widget class="QLineEdit" name="data_file">
           <property name="minimumSize">
            <size>
-            <width>300</width>
+            <width>200</width>
             <height>21</height>
            </size>
@@ -68,15 +55,18 @@
     </widget>
    </item>
-   <item row="3" column="0">
-    <widget class="QPushButton" name="closeButton">
-     <property name="toolTip">
-      <string>&lt;html&gt;&lt;head/&gt;&lt;body&gt;&lt;p&gt;Close this window.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</string>
+   <item row="2" column="0">
+    <spacer name="verticalSpacer_2">
+     <property name="orientation">
+      <enum>Qt::Vertical</enum>
      </property>
-     <property name="text">
-      <string>Close</string>
+     <property name="sizeHint" stdset="0">
+      <size>
+       <width>20</width>
+       <height>40</height>
+      </size>
      </property>
-    </widget>
+    </spacer>
    </item>
-   <item row="1" column="0" colspan="2">
+   <item row="1" column="0" colspan="3">
     <widget class="QGroupBox" name="groupBox_2">
      <property name="title">
@@ -94,8 +84,8 @@
         </item>
         <item>
-         <widget class="QLineEdit" name="lengthscale_out">
+         <widget class="QLineEdit" name="slit_length_out">
           <property name="minimumSize">
            <size>
-            <width>125</width>
+            <width>110</width>
             <height>21</height>
            </size>
@@ -118,10 +108,13 @@
         </item>
         <item>
-         <widget class="QLineEdit" name="lineEdit">
+         <widget class="QLineEdit" name="unit_out">
           <property name="minimumSize">
            <size>
-            <width>120</width>
+            <width>100</width>
             <height>21</height>
            </size>
+          </property>
+          <property name="readOnly">
+           <bool>true</bool>
           </property>
          </widget>
@@ -132,5 +125,5 @@
     </widget>
    </item>
-   <item row="0" column="1">
+   <item row="0" column="2">
     <widget class="QPushButton" name="browseButton">
      <property name="toolTip">
@@ -142,5 +135,5 @@
     </widget>
    </item>
-   <item row="3" column="1">
+   <item row="4" column="2">
     <widget class="QPushButton" name="helpButton">
      <property name="toolTip">
@@ -152,4 +145,40 @@
     </widget>
    </item>
+   <item row="4" column="0">
+    <spacer name="horizontalSpacer">
+     <property name="orientation">
+      <enum>Qt::Horizontal</enum>
+     </property>
+     <property name="sizeHint" stdset="0">
+      <size>
+       <width>40</width>
+       <height>20</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
+   <item row="4" column="1">
+    <widget class="QPushButton" name="closeButton">
+     <property name="toolTip">
+      <string>&lt;html&gt;&lt;head/&gt;&lt;body&gt;&lt;p&gt;Close this window.&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;</string>
+     </property>
+     <property name="text">
+      <string>Close</string>
+     </property>
+    </widget>
+   </item>
+   <item row="0" column="1">
+    <spacer name="horizontalSpacer_2">
+     <property name="orientation">
+      <enum>Qt::Horizontal</enum>
+     </property>
+     <property name="sizeHint" stdset="0">
+      <size>
+       <width>40</width>
+       <height>20</height>
+      </size>
+     </property>
+    </spacer>
+   </item>
   </layout>
  </widget>
Index: src/sas/qtgui/UnitTesting/SlitSizeCalculatorTest.py
===================================================================
--- src/sas/qtgui/UnitTesting/SlitSizeCalculatorTest.py	(revision 0532d7c15f8e5962a80241e030a2c4d28323411d)
+++ src/sas/qtgui/UnitTesting/SlitSizeCalculatorTest.py	(revision 0532d7c15f8e5962a80241e030a2c4d28323411d)
@@ -0,0 +1,105 @@
+import sys
+import unittest
+from PyQt4 import QtGui
+from PyQt4.QtTest import QTest
+from PyQt4.QtCore import Qt
+from mock import MagicMock
+
+# set up import paths
+import path_prepare
+
+from SlitSizeCalculator import SlitSizeCalculator
+from sas.sascalc.calculator.slit_length_calculator import SlitlengthCalculator as calculator
+from sas.sascalc.dataloader.loader import Loader
+
+app = QtGui.QApplication(sys.argv)
+
+
+class SlitSizeCalculatorTest(unittest.TestCase):
+    """Test the SlitSizeCalculator"""
+    def setUp(self):
+        """Create the SlitSizeCalculator"""
+        self.widget = SlitSizeCalculator(None)
+
+    def tearDown(self):
+        """Destroy the SlitSizeCalculator"""
+        self.widget.close()
+        self.widget = None
+
+    def testDefaults(self):
+        """Test the GUI in its default state"""
+        self.assertIsInstance(self.widget, QtGui.QWidget)
+        self.assertEqual(self.widget.windowTitle(), "Slit Size Calculator")
+        self.assertEqual(self.widget.sizePolicy().Policy(), QtGui.QSizePolicy.Fixed)
+
+    def testHelp(self):
+        """ Assure help file is shown """
+
+        # this should not rise
+        self.widget.onHelp()
+
+    def testComputeSlit(self):
+        """ User entered compound calculations and subsequent reset"""
+
+        filename = "beam_profile.DAT"
+        loader = Loader()
+        data = loader.load(filename)
+        # Push Compute with the left mouse button
+        cal = calculator()
+        cal.set_data(x = data.x, y = data.y)
+        slitlength = cal.calculate_slit_length()
+
+        # The value "5.5858" was obtained by manual calculation.
+        # It turns out our slit length is FWHM/2
+        self.assertAlmostEqual(slitlength,5.5858/2, 3)
+
+    def testBrowseButton(self):
+        browseButton = self.widget.browseButton
+
+        filename = "beam_profile.DAT"
+
+        # Return no files.
+        QtGui.QFileDialog.getOpenFileName = MagicMock(return_value=None)
+
+        # Click on the Browse button
+        QTest.mouseClick(browseButton, Qt.LeftButton)
+
+        # Test the getOpenFileName() dialog called once
+        self.assertTrue(QtGui.QFileDialog.getOpenFileName.called)
+        QtGui.QFileDialog.getOpenFileName.assert_called_once()
+
+        # Now, return a single file
+        QtGui.QFileDialog.getOpenFileName = MagicMock(return_value=filename)
+
+        # Click on the Load button
+        QTest.mouseClick(browseButton, Qt.LeftButton)
+        QtGui.qApp.processEvents()
+
+        # Test the getOpenFileName() dialog called once
+        self.assertTrue(QtGui.QFileDialog.getOpenFileName.called)
+        QtGui.QFileDialog.getOpenFileName.assert_called_once()
+
+    # def testDataEntryNumbers(self):
+    #     """ User entered compound calculations and subsequent reset"""
+    #
+    #     self.widget.data_file.clear()
+    #     self.widget.data_file.insert("beam profile.DAT")
+    #     #
+    #     # Push Compute with the left mouse button
+    #     computeButton = self.widget.computeButton
+    #     QTest.mouseClick(computeButton, Qt.LeftButton)
+    #     self.assertEqual(self.widget.lengthscale_out.text(), '6.283')
+    #
+    #
+    # def testComplexEntryLetters(self):
+    #     """ User entered compound calculations and subsequent reset"""
+    #
+    #     self.widget.deltaq_in.insert("xyz")
+    #
+    #     # Push Compute with the left mouse button
+    #     computeButton = self.widget.computeButton
+    #     QTest.mouseClick(computeButton, Qt.LeftButton)
+    #     self.assertEqual(self.widget.lengthscale_out.text(), '')
+
+if __name__ == "__main__":
+    unittest.main()